﻿; vim:foldcolumn=0:autoindent:autochdir:scrolloff=0:nocursorline:nocursorcolumn:scrolljump=0:startofline:nowrap:nobackup:noundofile:noswapfile:

; +---------------------------------------------------------------------------+
; |                                                                           |
; |  retroReader.ahk                                                          | 
; |  -------------------------------------------------------                  |
; |  Created: ~ beg 2016                                                      |
; |  Last Edited: 17 Jun 2017                                                 |
; |                                                                           |
; |  Script Purpose:                                                          |
; |  - allow The User to quickly scroll up and down a Document using Reader   |   
; |    The User is envisaged to use                                           |
; |    * The Scroll Wheel                                                     |
; |    for achieve this purpose                                               |
; |  - make the provision of Visual Crosshair                                 |
; |    The User has access to easily turn easily this on and off using the    |
; |    Right Mouse button                                                     |
; |  - make provision of 'Bmw Animations' the user can quickly can quickly    |
; |    switch on/off using The Middle Mouse Button                            |
; |  - allow The User to quickly quit The Script by clicking Left Mouse Button|
; |                                                                           |
; |  ToDo                                                                     |
; |  - new routine The Movement Routine                                       |
; |    idea is it gets repeatedly called                                      |
; |    something along lines of a thing to simulate inertia                   |
; |    a bit like a skateboard                                                |
; |    repeat push to build up speed                                          |
; |    eventually slowing down gradually coming to a halt                     |
; |  - the traditional joy oriented movement handlers                         |
; |    * CrosshairJoy()                                                       |
; |    * RightJoy()                                                           |
; |    need to be rewritten so that use is made of the 'new movement'         |
; |    counts given by The Movement Routine                                   |
; |  - The Movement Routine is gonna get called from handlers of The Mouse    |
; |    Wheel.  It acts as a sort of 'mechanical click counter'.  It is forseen|
; |    that the results of this 'counting' will be routed to what's already   |
; |    been written in RightJoy().  Specifically I'm referring to the bits    |
; |    that deal with the joystick                                            |
; |    but instead the feeding will be done from those 'counted in' values    |
; |    supplied by The Movement Routine.                                      |                                                                
; |  - the rewritten CrosshairJoy() will take into consideration the input    |    
; |    in the same sort of way as it did previously difference being instead  |
; |    of reading the values in from the joystick the values are gonna be fed |
; |    with values from The Mouse.                                            |
; |  - there needs to be a new Calibration routine that uses The Mouse Wheel  |
; |    * right at the beginning of the program                                |
; |    * Space Key to calibrate                                               |
; |      during flight                                                        |
; |                                                                           |
; +---------------------------------------------------------------------------+

#NoEnv  ; Recommended for performance and compatibility with future AutoHotkey releases.
#Persistent

; if not seems to go for some weird thing like control or something 
CoordMode, Mouse, Screen

; #Warn  ; Enable warnings to assist with detecting common errors.
SendMode Input  ; Recommended for new scripts due to its superior speed and reliability.
SetWorkingDir %A_ScriptDir%  ; Ensures a consistent starting directory.

Menu, Tray, Icon, retroReader.ico

SetTitleMatchMode,2

SystemCursor("Off")

bScrollStarted := 0
bScrollingNormalDownFlow := 0
bGotoToPageMode := 0
nGotoPageTarget := 0
bTestOK := 0
b_scanOn := 0
b_toggHighColour := 0
n_scanlineClr := 0
n_scanlineClrMax := 7
b_iRepeat := 0
n_bmwPanelsClr := 4
n_BMWrotationCounter := 0
n_crosshairPaintAcross_bmpWidth := 200
n_crosshairPaintAcross_bmpHeight := 3
n_crosshairPaintAcross_height := 3
n_crosshairPaintAcross_y := A_ScreenHeight//2
n_crosshairPaintDown_width = 3
n_crosshairPaintDown_bmpWidth := 3
n_crosshairPaintDown_bmpHeight := 200
n_crosshairPaintDown_x := A_ScreenWidth//2
b_crossOn = 0
n_crosshairDelay = 10
n_crosshairMinTransparency = 40
n_crosshairSP1 = 1
n_crosshairSP2 = 2
n_crosshairSP3 = 3
n_crosshairSP4 = 5
K_SCROLLSPEEDMAX = 7
K_SCROLLSPEEDALMOSTMAX = 5
K_SCROLLSPEEDALMOSTSLOW = 3
K_SCROLLSPEEDSLOW = 1
K_SCANHEIGHT := 21
n_mouseJoyWheelCounterInterrupt = 0
n_mouseJoyWheelCounterinterruptFreq = 2
n_mouseJoyWheelCounter = 50
b_wheelConfirmedAsUp = 0
b_wheelConfirmedAsDown = 0

;a few defaults
K_HALFSCREENWIDTH := A_ScreenWidth//2
K_HALFSCREENHEIGHT := A_ScreenHeight//2
K_TILLB4HALFWIDTH_TX := A_ScreenWidth//2-172
K_TILLAFHALFWIDTH_TX := A_ScreenWidth//2+188
K_TILLB4HALFWIDTH_CRSHRGIF := A_ScreenWidth-(n_crosshairPaintAcross_bmpWidth//2)
K_TILLB4HALFHEIGHT_CRSHRGIF := A_ScreenHeight-(n_crosshairPaintDown_bmpHeight//2)
K_BMWTRANSPARENCY := 25

;auto-cancel
b_scanCancel := 0
b_crossCancel := 0

;graphics cute animations
n_anim := 0
n_animsMax := 41
n_animShowCountdown := 0
n_animShowCountdownMax := 1
a_shuffleRecord := Object()
n_it = 0
while (n_it < n_animsMax)
{
	a_shuffleRecord[n_it] := 0
	n_it += 1
}
Random, n_anim, 0, %n_animsMax%

;pulsie effect
b_pulsieOn := 0
n_pulsieLevel := 0
n_pulsieDelta := 10
n_pulsieCounter := 0

;CONSTANTS
;  for crosshair removal
;  VERTICAL vs. HORIZONTAL
K_YAXIS := 100
K_XAXIS := 101

;  RANGE AVERIGUATION
K_GT := 300
K_GTE := 301
K_LT := 302
K_LTE := 303

; DIRECTION
K_TEXTFLOWINGDOWN := 400
K_TEXTFLOWINGUP := 401

;  gui1 vertical axis - line painted down the screen
Gui,+ToolWindow
Gui,Color, FF0000
Gui,Show,X0 Y0 H100 Y100
WinSet, AlwaysOnTop, On, A
WinSet, Style, -0xC00000, A
WinGet, n_crosshairPaintDown_id, ID, A
Gui,Show,X%n_crosshairPaintDown_x% Y0 H%A_ScreenHeight% W%n_crosshairPaintDown_width%
Gui,+Hwndhwnd_PD
WinSet, Transparent, 255, A
Gui,Hide

;  gui2 horizontal axis - line painted across the screen
Gui,New
Gui,2:+ToolWindow
Gui,2:Color, FF0000
Gui,2:Show,X0 Y0 H100 Y100
WinSet, AlwaysOnTop, On, A
WinSet, Style, -0xC00000, A
WinGet, n_crosshairPaintAcross_id, ID, A
Gui,2:Show,X0 Y%n_crosshairPaintAcross_y% H%n_crosshairPaintAcross_height% W%A_ScreenWidth%
Gui,2:+Hwndhwnd_PA
WinSet, Transparent, 255, A
Gui,2:Hide

;'police' panel
Gui,New
Gui,3:+ToolWindow
Gui,3:Color,EDF171
Gui,3:Show,X0 Y0 H100 Y100
WinSet, Style, -0xC00000, A
Gui,3:Show,X0 Y0 H%A_ScreenHeight% W%A_ScreenWidth%
Gui,3:Hide
WinActivate,Adobe
Sleep,800

;scan line panel
Gui,New
Gui,4:+ToolWindow
scanY0 := 100
Gui,4:Color,FF0000
Gui,4:Add,Text,vMyText W340 H18 X%K_TILLB4HALFWIDTH_TX% Y1 Center,wont be visible very long
Gui,4:Font,s12 cWhite,Arial
Gui,4:Show,X0 Y0 H200 W200
WinSet, Style, -0xC00000, A
WinGet, scanlinePanel_id, ID, A
Gui,4:Show,X0 Y%scanY0% H%K_SCANHEIGHT% W%A_ScreenWidth%
Gui,4:+Hwndhwnd_retro
h_aniGifRetro := AniGif_CreateControl(hwnd_retro, K_TILLAFHALFWIDTH_TX, 0, 42, 16, "center")
AniGif_LoadGifFromFile(h_aniGifRetro, "manicminer.gif")
AniGif_SetBkColor(h_aniGifRetro, 0xFF00FF)
Gui,4:Hide

;BMW panel-1
Gui,New
Gui,5:+ToolWindow
Gui,5:Color,777700
Gui,5:Show,X0 Y0 H800 W800
WinSet, AlwaysOnTop, On, A
WinSet, Style, -0xC00000, A
WinSet, Transparent, %K_BMWTRANSPARENCY%, A
WinGet, bmwpanel1_ID, ID, A
Gui,5:Hide

;BMW panel-2
Gui,New
Gui,6:+ToolWindow
Gui,6:Color,777700
Gui,6:Show,X0 Y0 H800 W800
WinSet, AlwaysOnTop, On, A
WinSet, Style, -0xC00000, A
WinSet, Transparent, %K_BMWTRANSPARENCY%, A
WinGet, bmwpanel2_ID, ID, A
Gui,6:Hide

SetTimer, MainLoop, 30
calibrate()
return

MainLoop:
if (b_calibrationInProgress)
{
	Sleep,30
	return
}
n_pulsieCounter += 1
if (b_scanOn)
{
	scanY0 := scanY0 + 1
	midScanY0 := scanY0 + (K_SCANHEIGHT//2)
	midScreenY := A_ScreenHeight//2
	if (midScanY0=midScreenYnY)
	{
		progressScanLine()
	}
	if (scanY0 > A_ScreenHeight)
	{
		scanY0 := -K_SCANHEIGHT
	}
	Gui,4:Show,X0 Y%scanY0% H%K_SCANHEIGHT% W%A_ScreenWidth%
}
if (b_crossOn)
{
	if (b_pulsieOn)
	{
		n_pulsieLevel += n_pulsieDelta
		if (n_pulsieLevel>96)
		{
			n_pulsieLevel := 96
			n_pulsieDelta := -2
		}
		if (n_pulsieLevel<10)
		{
			n_pulsieLevel := 10
			n_pulsieDelta := 2
		}
		WinSet, Transparent, %n_pulsieLevel%, ahk_id %n_crosshairPaintAcross_id%
		WinSet, Transparent, %n_pulsieLevel%, ahk_id %n_crosshairPaintDown_id% 
	}
	n_oldCrosshairPaintDown_x := n_crosshairPaintDown_x
	n_oldCrosshairPaintAcross_y := n_crosshairPaintAcross_y
	MouseGetPos, n_crosshairPaintDown_x, n_crosshairPaintAcross_y  
	UnpaintPaintCrosshairAsNecessary(n_oldCrosshairPaintDown_x, n_oldCrosshairPaintAcross_y)
} ; if (Not b_scanOn)
MouseWheelToRightJoyConverter(K_GTE, 0, K_LT, 9, n_mouseJoyWheelCounter, K_TEXTFLOWINGUP, K_SCROLLSPEEDMAX)
MouseWheelToRightJoyConverter(K_GTE, 10, K_LT, 20, n_mouseJoyWheelCounter, K_TEXTFLOWINGUP, K_SCROLLSPEEDALMOSTMAX)
MouseWheelToRightJoyConverter(K_GTE, 21, K_LT, 32, n_mouseJoyWheelCounter, K_TEXTFLOWINGUP, K_SCROLLSPEEDALMOSTSLOW)
MouseWheelToRightJoyConverter(K_GTE, 33, K_LT, 40, n_mouseJoyWheelCounter, K_TEXTFLOWINGUP, K_SCROLLSPEEDSLOW)
MouseWheelToRightJoyConverter(K_GTE, 40, K_LTE, 61, n_mouseJoyWheelCounter, 0, 0)
MouseWheelToRightJoyConverter(K_GT, 61, K_LTE, 67, n_mouseJoyWheelCounter, K_TEXTFLOWINGDOWN, K_SCROLLSPEEDSLOW)
MouseWheelToRightJoyConverter(K_GT, 68, K_LTE, 79, n_mouseJoyWheelCounter, K_TEXTFLOWINGDOWN, K_SCROLLSPEEDALMOSTSLOW)
MouseWheelToRightJoyConverter(K_GT, 80, K_LTE, 90, n_mouseJoyWheelCounter, K_TEXTFLOWINGDOWN, K_SCROLLSPEEDALMOSTMAX)
MouseWheelToRightJoyConverter(K_GT, 91, K_LTE, 100, n_mouseJoyWheelCounter, K_TEXTFLOWINGDOWN, K_SCROLLSPEEDMAX)
n_mouseJoyWheelCounterInterrupt += 1
if (0=Mod(n_mouseJoyWheelCounterInterrupt,n_mouseJoyWheelCounterinterruptFreq))
{
	if (n_mouseJoyWheelCounter < 50)
		n_mouseJoyWheelCounter++
	if (n_mouseJoyWheelCounter > 50)
		n_mouseJoyWheelCounter--
}
return

; crosshairs will not be repainted if passed old values same as current values
; note the parameters are for reference
; they are not what actually gets updated
UnpaintPaintCrosshairAsNecessary(n_oldCrosshairPaintDown_x, n_oldCrosshairPaintAcross_y)
{
	global n_crosshairPaintDown_x, n_crosshairPaintAcross_y
	n_temp = 0

	if ((n_oldCrosshairPaintDown_x != n_crosshairPaintDown_x) || (n_oldCrosshairPaintAcross_y != n_crosshairPaintAcross_y))
	{
		Gui,1:Show,X%n_crosshairPaintDown_x% Y0
		Gui,2:Show,X0 Y%n_crosshairPaintAcross_y%
	}
}

; direction will not be used if speed is 0
MouseWheelToRightJoyConverter(cp1, cp1v, cp2, cp2v, n_mouseJoyWheelCounter, direction, speed)
{
	global K_GTE, K_GT, K_LTE, K_LT
	global K_TEXTFLOWINGUP, K_TEXTFLOWINGDOWN
	global b_scanCancel, b_crossCancel
	global bScrollStarted, bScrollingNormalDownFlow
	b_cp1 := 0
	b_cp2 := 0

	if (cp1=K_GT And n_mouseJoyWheelCounter>cp1v)
	{
		b_cp1 := 1
	}
	if (cp1=K_GTE And n_mouseJoyWheelCounter>=cp1v)
	{
		b_cp1 := 1
	}
	if (cp2=K_LT And n_mouseJoyWheelCounter<cp2v)
	{
		b_cp2 := 1
	}
	if (cp2=K_LTE And n_mouseJoyWheelCounter<=cp2v)
	{
		b_cp2 := 1
	}
	; COMPARISON 1: acting starting/continue moving
	if (b_cp1 And b_cp2 And 0!=speed)
	{
		sav_crossCancel := b_crossCancel
		sav_scanCancel := b_scanCancel
		CancelScanningIfStarted() ; <-- these change the status
		CancelCrosshairIfActive() ; <-- ...
		if (b_crossCancel!=sav_crossCancel || b_scanCancel!=sav_scanCancel)
			b_myUIWasOn := 1
		else
			b_myUIWasOn := 0
		if (b_myUIWasOn)
		{
			SetTitleMatchMode,2
			WinWaitActive,Reader,,2
		}
		if (Not bScrollStarted) ; you can assume it's activated
		{
			Send,^+h
			bScrollStarted := 1
			; there needs to be a bit of a condideration about whether my
			; GUI gadets were on top first 'cause they take time to undraw!
			if (b_myUIWasOn)
				Sleep,320 ; I put this up to 320 (250) because sometimes crosshair was getting left
		}
		if (bScrollStarted And Not bScrollingNormalDownFlow And direction=K_TEXTFLOWINGUP)
		{
			Send,-
			bScrollingNormalDownFlow := 1
		}
		if (bScrollStarted And bScrollingNormalDownFlow And direction=K_TEXTFLOWINGDOWN)
		{
			Send,-
			bScrollingNormalDownFlow := 0
		}
		Send,%speed%
	}
	; COMPARISON 2: acting stopping
	; these two comparisons are mutually exclusive
	if (b_cp1 And b_cp2 And 0=speed)
	{
		if (bScrollStarted)
		{
			SetTitleMatchMode,2
			WinWaitActive,Reader,,2
			Send,^+h
			Sleep,150
			bScrollStarted := 0
		}
		SeeIfScanningNeedsRestart()
		SeeIfCrosshairNeedsRestart()
	}
}

SeeIfScanningNeedsRestart()
{
	global b_scanCancel

	if (b_scanCancel)
	{
		iWouldLikeScanningToStart()
		b_scanCancel := 0
	}
}

SeeIfCrosshairNeedsRestart()
{
	global b_crossCancel, b_crossOn

	if (b_crossCancel)
	{
		Gui,1:Show
		Gui,2:Show
		b_crossOn := 1
		b_crossCancel := 0
	}
}

CancelCrosshairIfActive() ; the assumption called only if scanning
{
	global b_crossOn, b_crossCancel

	if (b_crossOn)
	{
		Gui,1:Hide
		Sleep,30
		Gui,2:Hide
		Sleep,30
		;^^ if you don't put Sleeps in  the system can leave a 'ghost'
		;
		b_crossOn := 0
		b_crossCancel := 1
	}
}

TurnPulsieOn()
{
	global b_pulsieOn, n_pulsieLevel, n_pulsieDelta

	b_pulsieOn := 1
	n_pulsieLevel := 255
	n_pulsieDelta := -10
}

TurnPulsieOff()
{
	global b_pulsieOn, n_crosshairPaintAcross_id, n_crosshairPaintDown_id

	b_pulsieOn := 0
	WinSet, Transparent, 255, ahk_id %n_crosshairPaintAcross_id%
	WinSet, Transparent, 255, ahk_id %n_crosshairPaintDown_id% 
}

CancelScanningIfStarted()
{
	global b_scanOn, b_scanCancel

	if (b_scanOn)
	{
		b_scanCancel := 1
		iWouldLikeScanningToStop()
	}
}

progressScanLine()
{
	global n_scanlineClr
	global n_scanlineClrMax
	global n_BMWrotationCounter
	global h_aniGifRetro
	global n_anim
	global n_animsMax
	global hwnd_retro
	global K_TILLAFHALFWIDTH_TX
	global n_animShowCountdown
	global n_animShowCountdownMax

	n_animShowCountdown -= 1
	if (n_animShowCountdown <= 0)
	{
		n_animShowCountdown := n_animShowCountdownMax
		AniGif_DestroyControl(h_aniGifRetro) 
		if (n_anim = 0)
		{
			h_aniGifRetro := AniGif_CreateControl(hwnd_retro, K_TILLAFHALFWIDTH_TX, 1, 85, 18, "center")
			AniGif_LoadGifFromFile(h_aniGifRetro, "monsters.gif")
		}
		if (n_anim = 1)
		{
			h_aniGifRetro := AniGif_CreateControl(hwnd_retro, K_TILLAFHALFWIDTH_TX, 0, 160, 21, "center")
			AniGif_LoadGifFromFile(h_aniGifRetro, "snapper.gif")
		}
		if (n_anim = 2)
		{
			h_aniGifRetro := AniGif_CreateControl(hwnd_retro, K_TILLAFHALFWIDTH_TX, 0, 80, 21, "center")
			AniGif_LoadGifFromFile(h_aniGifRetro, "arcadians.gif")
		}
		if (n_anim = 3)
		{
			h_aniGifRetro := AniGif_CreateControl(hwnd_retro, K_TILLAFHALFWIDTH_TX, 0, 140, 21, "center")
			AniGif_LoadGifFromFile(h_aniGifRetro, "hopper.gif")
		}
		if (n_anim = 4)
		{
			h_aniGifRetro := AniGif_CreateControl(hwnd_retro, K_TILLAFHALFWIDTH_TX, 1, 100, 18, "center")
			AniGif_LoadGifFromFile(h_aniGifRetro, "killa.gif")
		}
		if (n_anim = 5)
		{
			h_aniGifRetro := AniGif_CreateControl(hwnd_retro, K_TILLAFHALFWIDTH_TX, 1, 63, 18, "center")
			AniGif_LoadGifFromFile(h_aniGifRetro, "blagger.gif")
		}
		if (n_anim = 6)
		{
			h_aniGifRetro := AniGif_CreateControl(hwnd_retro, K_TILLAFHALFWIDTH_TX, 0, 215, 20, "center")
			AniGif_LoadGifFromFile(h_aniGifRetro, "rocket.gif")
		}
		if (n_anim = 7)
		{
			h_aniGifRetro := AniGif_CreateControl(hwnd_retro, K_TILLAFHALFWIDTH_TX, 0, 126, 21, "center")
			AniGif_LoadGifFromFile(h_aniGifRetro, "exile.gif")
		}
		if (n_anim = 8)
		{
			h_aniGifRetro := AniGif_CreateControl(hwnd_retro, K_TILLAFHALFWIDTH_TX, 0, 100, 21, "center")
			AniGif_LoadGifFromFile(h_aniGifRetro, "fire.gif")
		}
		if (n_anim = 9)
		{
			h_aniGifRetro := AniGif_CreateControl(hwnd_retro, K_TILLAFHALFWIDTH_TX, 0, 160, 21, "center")
			AniGif_LoadGifFromFile(h_aniGifRetro, "repton.gif")
		}
		if (n_anim = 10)
		{
			h_aniGifRetro := AniGif_CreateControl(hwnd_retro, K_TILLAFHALFWIDTH_TX, 0, 95, 21, "center")
			AniGif_LoadGifFromFile(h_aniGifRetro, "citadel.gif")
		}
		if (n_anim = 11)
		{
			h_aniGifRetro := AniGif_CreateControl(hwnd_retro, K_TILLAFHALFWIDTH_TX, 0, 160, 21, "center")
			AniGif_LoadGifFromFile(h_aniGifRetro, "castlequest.gif")
		}
		if (n_anim = 12)
		{
			h_aniGifRetro := AniGif_CreateControl(hwnd_retro, K_TILLAFHALFWIDTH_TX, 0, 150, 21, "center")
			AniGif_LoadGifFromFile(h_aniGifRetro, "imogen.gif")
		}
		if (n_anim = 13)
		{
			h_aniGifRetro := AniGif_CreateControl(hwnd_retro, K_TILLAFHALFWIDTH_TX, 0, 105, 21, "center")
			AniGif_LoadGifFromFile(h_aniGifRetro, "revs.gif")
		}
		if (n_anim = 14)
		{
			h_aniGifRetro := AniGif_CreateControl(hwnd_retro, K_TILLAFHALFWIDTH_TX, 0, 85, 21, "center")
			AniGif_LoadGifFromFile(h_aniGifRetro, "raven.gif")
		}
		if (n_anim = 15)
		{
			h_aniGifRetro := AniGif_CreateControl(hwnd_retro, K_TILLAFHALFWIDTH_TX, 0, 138, 21, "center")
			AniGif_LoadGifFromFile(h_aniGifRetro, "strykers.gif")
		}
		if (n_anim = 16)
		{
			h_aniGifRetro := AniGif_CreateControl(hwnd_retro, K_TILLAFHALFWIDTH_TX, 0, 130, 21, "center")
			AniGif_LoadGifFromFile(h_aniGifRetro, "simcity.gif")
		}
		if (n_anim = 17)
		{
			h_aniGifRetro := AniGif_CreateControl(hwnd_retro, K_TILLAFHALFWIDTH_TX, 0, 95, 21, "center")
			AniGif_LoadGifFromFile(h_aniGifRetro, "frak.gif")
		}
		if (n_anim = 18)
		{
			h_aniGifRetro := AniGif_CreateControl(hwnd_retro, K_TILLAFHALFWIDTH_TX, 0, 160, 21, "center")
			AniGif_LoadGifFromFile(h_aniGifRetro, "galaforce.gif")
		}
		if (n_anim = 19)
		{
			h_aniGifRetro := AniGif_CreateControl(hwnd_retro, K_TILLAFHALFWIDTH_TX, 0, 160, 21, "center")
			AniGif_LoadGifFromFile(h_aniGifRetro, "thrust.gif")
		}
		if (n_anim = 20)
		{
			h_aniGifRetro := AniGif_CreateControl(hwnd_retro, K_TILLAFHALFWIDTH_TX, 0, 204, 21, "center")
			AniGif_LoadGifFromFile(h_aniGifRetro, "podd.gif")
		}
		if (n_anim = 21)
		{
			h_aniGifRetro := AniGif_CreateControl(hwnd_retro, K_TILLAFHALFWIDTH_TX, 0, 85, 21, "center")
			AniGif_LoadGifFromFile(h_aniGifRetro, "palace.gif")
		}
		if (n_anim = 22)
		{
			h_aniGifRetro := AniGif_CreateControl(hwnd_retro, K_TILLAFHALFWIDTH_TX, 0, 180, 21, "center")
			AniGif_LoadGifFromFile(h_aniGifRetro, "starswarm.gif")
		}
		if (n_anim = 23)
		{
			h_aniGifRetro := AniGif_CreateControl(hwnd_retro, K_TILLAFHALFWIDTH_TX, 0, 90, 21, "center")
			AniGif_LoadGifFromFile(h_aniGifRetro, "deep.gif")
		}
		if (n_anim = 24)
		{
			h_aniGifRetro := AniGif_CreateControl(hwnd_retro, K_TILLAFHALFWIDTH_TX, 0, 90, 21, "center")
			AniGif_LoadGifFromFile(h_aniGifRetro, "cliff.gif")
		}
		if (n_anim = 25)
		{
			h_aniGifRetro := AniGif_CreateControl(hwnd_retro, K_TILLAFHALFWIDTH_TX, 0, 90, 21, "center")
			AniGif_LoadGifFromFile(h_aniGifRetro, "cuthbert.gif")
		}
		if (n_anim = 26)
		{
			h_aniGifRetro := AniGif_CreateControl(hwnd_retro, K_TILLAFHALFWIDTH_TX, 0, 70, 21, "center")
			AniGif_LoadGifFromFile(h_aniGifRetro, "tombs.gif")
		}
		if (n_anim = 27)
		{
			h_aniGifRetro := AniGif_CreateControl(hwnd_retro, K_TILLAFHALFWIDTH_TX, 0, 60, 21, "center")
			AniGif_LoadGifFromFile(h_aniGifRetro, "darktower.gif")
		}
		if (n_anim = 28)
		{
			h_aniGifRetro := AniGif_CreateControl(hwnd_retro, K_TILLAFHALFWIDTH_TX, 0, 70, 21, "center")
			AniGif_LoadGifFromFile(h_aniGifRetro, "booty.gif")
		}
		if (n_anim = 29)
		{
			h_aniGifRetro := AniGif_CreateControl(hwnd_retro, K_TILLAFHALFWIDTH_TX, 0, 70, 21, "center")
			AniGif_LoadGifFromFile(h_aniGifRetro, "cosmic.gif")
		}
		if (n_anim = 30)
		{
			h_aniGifRetro := AniGif_CreateControl(hwnd_retro, K_TILLAFHALFWIDTH_TX, 0, 46, 21, "center")
			AniGif_LoadGifFromFile(h_aniGifRetro, "maniac.gif")
		}
		if (n_anim = 31)
		{
			h_aniGifRetro := AniGif_CreateControl(hwnd_retro, K_TILLAFHALFWIDTH_TX, 0, 128, 21, "center")
			AniGif_LoadGifFromFile(h_aniGifRetro, "great.gif")
		}
		if (n_anim = 32)
		{
			h_aniGifRetro := AniGif_CreateControl(hwnd_retro, K_TILLAFHALFWIDTH_TX, 0, 74, 21, "center")
			AniGif_LoadGifFromFile(h_aniGifRetro, "imposs.gif")
		}
		if (n_anim = 33)
		{
			h_aniGifRetro := AniGif_CreateControl(hwnd_retro, K_TILLAFHALFWIDTH_TX, 0, 100, 21, "center")
			AniGif_LoadGifFromFile(h_aniGifRetro, "bubble.gif")
		}
		if (n_anim = 34)
		{
			h_aniGifRetro := AniGif_CreateControl(hwnd_retro, K_TILLAFHALFWIDTH_TX, 0, 102, 21, "center")
			AniGif_LoadGifFromFile(h_aniGifRetro, "karate.gif")
		}
		if (n_anim = 35)
		{
			h_aniGifRetro := AniGif_CreateControl(hwnd_retro, K_TILLAFHALFWIDTH_TX, 0, 70, 21, "center")
			AniGif_LoadGifFromFile(h_aniGifRetro, "space.gif")
		}
		if (n_anim = 36)
		{
			h_aniGifRetro := AniGif_CreateControl(hwnd_retro, K_TILLAFHALFWIDTH_TX, 0, 75, 21, "center")
			AniGif_LoadGifFromFile(h_aniGifRetro, "turrican.gif")
		}
		if (n_anim = 37)
		{
			h_aniGifRetro := AniGif_CreateControl(hwnd_retro, K_TILLAFHALFWIDTH_TX, 0, 43, 21, "center")
			AniGif_LoadGifFromFile(h_aniGifRetro, "wiz.gif")
		}
		if (n_anim = 38)
		{
			h_aniGifRetro := AniGif_CreateControl(hwnd_retro, K_TILLAFHALFWIDTH_TX, 0, 76, 21, "center")
			AniGif_LoadGifFromFile(h_aniGifRetro, "bongo.gif")
		}
		if (n_anim = 39)
		{
			h_aniGifRetro := AniGif_CreateControl(hwnd_retro, K_TILLAFHALFWIDTH_TX, 0, 76, 21, "center")
			AniGif_LoadGifFromFile(h_aniGifRetro, "gonzo.gif")
		}
		if (n_anim = 40)
		{
			h_aniGifRetro := AniGif_CreateControl(hwnd_retro, K_TILLAFHALFWIDTH_TX, 0, 63, 21, "center")
			AniGif_LoadGifFromFile(h_aniGifRetro, "ninja.gif")
		}
		n_scanlineClr := Mod(n_scanlineClr+1, n_scanlineClrMax)
		changeTextAndLineColours()
		n_anim := PickOutNextRandom()
		n_BMWrotationCounter += 1
		experta_SetupAndShowBMWPanels()
	}
	GuiControl,4:,MyText,%A_YYYY% %A_MMM% %A_DD% %A_Hour%:%A_Min% of a %A_DDDD%
}
; progressScanLine()


changeTextAndLineColours()
{
	global n_scanlineClr
	global h_aniGifRetro

	; ..grey
	if (n_scanlineClr = 0)
	{
		Gui,4:Color,888888
		Gui,4:Font,cWhite
		GuiControl,4:Font,MyText
		AniGif_SetBkColor(h_aniGifRetro, 0x888888)
	}
	; ..red
	if (n_scanlineClr = 1)
	{
		Gui,4:Color,FF0000
		Gui,4:Font,cYellow
		GuiControl,4:Font,MyText
		AniGif_SetBkColor(h_aniGifRetro, 0x0000FF)
	}
	; ..blue
	if (n_scanlineClr = 1)
	{
		Gui,4:Color,0000FF
		Gui,4:Font,cWhite
		GuiControl,4:Font,MyText
		AniGif_SetBkColor(h_aniGifRetro, 0xFF0000)
	}
	; ..green
	if (n_scanlineClr = 2)
	{
		Gui,4:Color,44DD00
		Gui,4:Font,c0000EE
		GuiControl,4:Font,MyText
		AniGif_SetBkColor(h_aniGifRetro, 0x00DD44)
	}
	; ..yellow
	if (n_scanlineClr = 3)
	{
		Gui,4:Color,FFDD00
		Gui,4:Font,c00CC00
		GuiControl,4:Font,MyText
		AniGif_SetBkColor(h_aniGifRetro, 0x00DDFF)
	}
	; ..orange
	if (n_scanlineClr = 4)
	{
		Gui,4:Color,FF8800
		Gui,4:Font,cWhite
		GuiControl,4:Font,MyText
		AniGif_SetBkColor(h_aniGifRetro, 0x0088FF)
	}
	; ..cyan
	if (n_scanlineClr = 5)
	{
		Gui,4:Color,00DDDD
		Gui,4:Font,cBlack
		GuiControl,4:Font,MyText
		AniGif_SetBkColor(h_aniGifRetro, 0xDDDD00)
	}
	; ..magenta
	if (n_scanlineClr = 6)
	{
		Gui,4:Color,FF00FF
		Gui,4:Font,cWhite
		GuiControl,4:Font,MyText
		AniGif_SetBkColor(h_aniGifRetro, 0xFF00FF)
	}
}

; note height and width mean panel
showBMWPanels(midStartX,midStartY,height,width,n_LorRpanel1or2, counter)
{
	if (1=n_LorRpanel1or2)
	{
		n_LorRpanel1or2 := 5
	}
	else
	{
		n_LorRpanel1or2 := 6
	}
	n_moverY := 0
	n_moverX := 0
	if (0=Mod(counter,4))
	{
		n_moverX := 0
		while (n_moverX <= midStartX)
		{
			Gui,%n_LorRpanel1or2%:Show,x%n_moverX% y0 h%height% w%width%
			n_moverX += 4
		}
		Gui,%n_LorRpanel1or2%:Show,x%n_moverX% y0 h%height% w%width%
	}
	if (1=Mod(counter,4))
	{
		n_moverY := 0
		while (n_moverY <= midStartY)
		{
			Gui,%n_LorRpanel1or2%:Show,x%midStartX% y%n_moverY% h%height% w%width%
			n_moverY += 4
		}
		Gui,%n_LorRpanel1or2%:Show,x%midStartX% y%midStartY% h%height% w%width%
	}
	if (2=Mod(counter,4))
	{
		n_moverX := midStartX
		while (n_moverX > 0)
		{
			Gui,%n_LorRpanel1or2%:Show,x%n_moverX% y%midStartY% h%height% w%width%
			n_moverX -= 4
		}
		Gui,%n_LorRpanel1or2%:Show,x%n_moverX% y%midStartY% h%height% w%width%
	}
	if (3=Mod(counter,4))
	{
		n_moverY := midStartY
		while (n_moverY >= 0)
		{
			Gui,%n_LorRpanel1or2%:Show,x0 y%n_moverY% h%height% w%width%
			n_moverY -= 4
		}
		Gui,%n_LorRpanel1or2%:Show,x0 y0 h%height% w%width%
	}
}

experta_SetupAndShowBMWPanels()
{
	global bmwpanel1_ID, bmwpanel2_ID
	global n_BMWrotationCounter

	height := A_ScreenHeight//2
	width := A_ScreenWidth//2
	bmwMidX := A_ScreenWidth//2
	bmwMidY := A_ScreenHeight//2
	counter := n_BMWrotationCounter
	showBMWPanels(bmwMidX,bmwMidY,height,width,1,counter)
	bmwMidX := width
	bmwMidY := height + 1
	counter := n_BMWrotationCounter+2
	showBMWPanels(bmwMidX,bmwMidY,height,width,2,counter)
}

iWouldLikeScanningToStart()
{
	global b_scanOn
	static firstTime = 1

	if (!b_scanOn)
	{
		experta_SetupAndShowBMWPanels()
		if (firstTime)
		{
			GuiControl,4:,MyText,Loading.. please wait!
			firstTime := 0
		}
		else
		{
			GuiControl,4:,MyText,%A_YYYY% %A_MMM% %A_DD% %A_Hour%:%A_Min% of a %A_DDDD%
		}
		b_scanOn := 1
	}
}

iWouldLikeScanningToStop()
{
	global b_scanOn
	b_scanOn := 0

	Gui,4:Hide
	Sleep,30
	;^^ if you don't put Sleeps in  the system can leave a 'ghost'
	;
	Gui,5:Hide
	Sleep,30
	;^^ if you don't put Sleeps in  the system can leave a 'ghost'
	;
	Gui,6:Hide
	Sleep,30
	;^^ if you don't put Sleeps in  the system can leave a 'ghost'
	;
}

displayConfigInput(stage)
{
	global b_calibrationInProgress, b_wheelConfirmedAsUp, b_wheelConfirmedAsDown

	Gui,configInput:New
	if (1=stage)
	{
		Gui,configInput:Add, Picture, w480 h240, calibrate1.png
	}
	if (2=stage)
	{
		Gui,configInput:Add, Picture, w480 h240, calibrate2.png
	}
	Gui,configInput:Color,FFFFFF
	Gui,configInput:Show,AutoSize Center
	WinSet, Style, -0xC00000, A
	b_calibrationInProgress = 1
	; ^^ note side effect each time switches on
	;
	b_wheelConfirmedAsUp = 0
	b_wheelConfirmedAsDown = 0
	; 
	; then the wheel handlers switch it off again
	; 
	While (!b_wheelConfirmedAsUp && !b_wheelConfirmedAsDown)
	{
		Sleep, 250
	}
	Gui,configInput:Hide
	return
}


calibrate()
{
	global b_wheelConfirmedAsUp, b_wheelConfirmedAsDown, b_crossOn

	Gui,1:Hide
	Sleep,30
	Gui,2:Hide
	Sleep,30
	;^^ if you don't put Sleeps in  the system can leave a 'ghost'
	;
	b_crossOn = 0
	iWouldLikeScanningToStop()
	WinActivate,Reader
	; I'm removing these early feb 2018
	; reason being 
	; I had a Revelation
	; ESC can definitely stop reader moving
	; ...
	;Sleep,500
	; ... this function would have asked user is text moving
	;displayConfigInput(1)
	;if (b_wheelConfirmedAsUp)
	;{
		;Send,^+h
	;}
	;Sleep,250
	;Send,^+h
	;Sleep,250
	Sleep 500,
	Send,{Esc}
	Send,^+h
	Sleep,250
	displayConfigInput(2)
	if (b_wheelConfirmedAsUp)
	{
		bScrollingNormalDownFlow = 1
	}
	else
	{
		bScrollingNormalDownFlow = 0
	}
	Gui,configInput:New
	Gui,configInput:Add, Picture, w480 h240, dontTouchArghh.png
	Gui,configInput:Color,FFFFFF
	;WinSet, Region, H480 W240 R30-30, A
	Gui,configInput:Show,AutoSize Center
	WinSet, Style, -0xC00000, A
	Sleep,1400
	Gui,configInput:Hide
	Sleep,1000
	Send,1
	Send,^+h
	Gui,configInput:New
	Gui,configInput:Add, Picture, w480 h240, itsOkNow.png
	Gui,configInput:Color,FFFFFF
	;WinSet, Region, H480 W240 R30-30, A
	Gui,configInput:Show,AutoSize Center
	WinSet, Style, -0xC00000, A
	Sleep,1800
	Gui,configInput:Hide
	ReminderOfKeys()
	return
}

SeeIfMouseNeedsTurnOn()
{
	global b_crossOn, b_scanOn

	if (!b_crossOn And !b_scanOn)
	{
		SystemCursor("On")
	}
	else
	{
		SystemCursor("Off")
	}
	return
}

GiveUpByLookingInBag()
{
	global a_shuffleRecord, n_animsMax
	n_it = 0

	while (a_shuffleRecord[n_it]=1 And n_it<n_animsMax)
	{
		n_it += 1
	}
	if (n_it = n_animsMax)
	{
		n_it = 0
		while (n_it<n_animsMax)
		{
			a_shuffleRecord[n_it] := 0
			n_it += 1
		}
		Random, n_it, 0, %n_animsMax%
	}
	a_shuffleRecord[n_it] := 1
	return n_it
}

PickOutNextRandom()
{
	global a_shuffleRecord, n_animsMax
	n_maxTries = 100
	n_tries = 0
	n_thisThat = 0

	while (n_tries < n_maxTries)
	{
		Random, n_thisThat, 0, %n_animsMax%
		if (a_shuffleRecord[n_thisThat] = 0)
		{
			a_shuffleRecord[n_thisThat] := 1
			return n_thisThat
		}
		n_tries += 1
	}
	n_thisThat := GiveUpByLookingInBag()
	return n_thisThat
}

ReminderOfKeys()
{
	Gui,3:Show
	WinSet, Style, -0xC00000, A
	Gui,configInput:New
	Gui,configInput:Add, Picture, w480 h240, rememberTheKeys.png
	Gui,configInput:Color,FFFFFF
	Gui,configInput:+Hwndhwnd_theKeys
	h_aniGifTheKeys := AniGif_CreateControl(hwnd_theKeys, 20, 20, 480, 240, "center")
	AniGif_LoadGifFromFile(h_aniGifTheKeys, "rememberTheKeys.gif")
	;AniGif_SetBkColor(h_aniGifRetro, 0xFF00FF)
	Gui,configInput:Show,AutoSize Center
	WinSet, Style, -0xC00000, A
	WinSet, Region, 20-20 W480 H240 R30-30, A
	Sleep,10880
	Gui,configInput:Hide
	Gui,3:Hide
}


isInScrollbar()
{
	MouseGetPos, nMouseX, nMouseY
	if ((A_ScreenWidth-40<nMouseX))
	{
		return 1
	}
	else
	{
		return 0
	}
}

WheelUp::
if (isInScrollbar())
{
	Send,{PgUp}
}
else
{
	if (b_calibrationInProgress)
	{
		b_calibrationInProgress = 0
		b_wheelConfirmedAsUp = 1
		return
	}
	n_mouseJoyWheelCounter -= 9
	if (n_mouseJoyWheelCounter<0)
		n_mouseJoyWheelCounter=0
}
return

WheelDown::
if (isInScrollbar())
{
	Send,{PgDn}
}
else
{
	if (b_calibrationInProgress)
	{
		b_calibrationInProgress = 0
		b_wheelConfirmedAsDown = 1
		return
	}
	n_mouseJoyWheelCounter += 9
	if (n_mouseJoyWheelCounter>100)
		n_mouseJoyWheelCounter=100
}
return

q::
AniGif_DestroyControl(h_aniGifRetro) 
AniGif_DestroyControl(h_aniGifTheKeys)
SystemCursor("On")
Gui,configInput:New
Gui,configInput:Add, Picture, w480 h240, seeYa.png
Gui,configInput:Color,FFFFFF
Gui,configInput:Show,AutoSize Center
WinSet, Style, -0xC00000, A
Sleep,1800
Gui,configInput:Hide
ExitApp
return

RButton::
if (n_mouseJoyWheelCounter!=50)
	return
; ^^ don't allow while moving
; cross on
if (Not b_crossOn)
{
	if (b_scanOn)
	{
		iWouldLikeScanningToStop()
	}
	;show crosshair
	Gui,1:Show
	Gui,2:Show
	b_crossOn = 1
}
else
{
	if (b_scanOn)
	{
		iWouldLikeScanningToStop()
		return
	}
	;hide crosshair
	Gui,1:Hide
	Sleep,30
	Gui,2:Hide
	Sleep,30
	;^^ if you don't put Sleeps in  the system can leave a 'ghost'
	;
	b_crossOn = 0
}
SeeIfMouseNeedsTurnOn()
return

c::
if (n_mouseJoyWheelCounter!=50)
	return
; ^^ don't allow while moving
; force calibrate
calibrate()
return

MButton::
if (n_mouseJoyWheelCounter!=50)
	return
; ^^ don't allow while moving
; scan on
b_scanCancel := 0
if (b_scanOn)
{
	iWouldLikeScanningToStop()
}
else
{
	n_BMWrotationCounter += 1
	iWouldLikeScanningToStart()
}
SeeIfMouseNeedsTurnOn()
return

p::
if (n_mouseJoyWheelCounter!=50)
	return
; ^^ don't allow while moving
if (b_pulsieOn)
{
	WinSet, Transparent, 255, ahk_id %n_crosshairPaintAcross_id%
	WinSet, Transparent, 255, ahk_id %n_crosshairPaintDown_id% 
	b_pulsieOn = 0
	; ^^ this is just for testing
	;TurnPulsieOff()
}
else
{
	WinSet, Transparent, 200, ahk_id %n_crosshairPaintAcross_id%
	WinSet, Transparent, 200, ahk_id %n_crosshairPaintDown_id% 
	b_pulsieOn = 1
	; ^^ this is just for testing
	;TurnPulsieOn()
}
return

AniGif_CreateControl(_guiHwnd, _x, _y, _w, _h,_style=""){
	local hAniGif, agHwnd
	local msg, style 
	static $bFirstCall := true

	If ($bFirstCall)
	{
		$bFirstCall := false
		; It will be unloaded at script end
		hAniGif := DllCall("LoadLibrary", "Str", "AniGif.dll")
	}
	style := 0
	If (_style != "")
	{
		If _style contains autosize
			style |= 1	; WAGS_AUTOSIZE
		If _style contains center
			style |= 2	; WAGS_CENTER
		If _style contains hyperlink
			style |= 4	; WAGS_HYPERLINK
	}	
	style := 0x50000000 | style	
	agHwnd := DLLCall("CreateWindowEx"
			, "UInt", 0                     ; Style, can be WS_EX_CLIENTEDGE = 0x200
			, "Str", "AniGIF"               ; Class Name
			, "Str", "AnimatedGif"          ; Window name
			, "UInt",  style                ; Window style
			, "Int", _x                     ; X position
			, "Int", _y                     ; Y position
			, "Int", _w                     ; Width
			, "Int", _h                     ; Height
			, "UInt", _guiHwnd              ; Handle of parent
			, "UInt", 0                     ; Menu
			, "UInt", 0               ; hInstance of the module registering the component's class
			, "UInt", 0)                    ; User defined style

	If (ErrorLevel != 0 or agHwnd = 0)
	{
		msg = %msg% Cannot create AniGif control (%ErrorLevel%/%A_LastError%)
		Gosub AniGif_CreateControl_CleanUp
		Return msg
	}
	Return agHwnd

AniGif_CreateControl_CleanUp:	; In case of error	
Return
}

AniGif_DestroyControl(_agHwnd)
{
	If (_agHwnd != 0)
	{
		AniGif_UnloadGif(_agHwnd)
		DllCall("DestroyWindow", "UInt", _agHwnd)
	}
}

AniGif_LoadGifFromFile(_agHwnd, _gifFile)
{	
	VarSetCapacity(var, StrPut(_gifFile, "cp0") * 2)
	StrPut(_gifFile, &var, "cp0")
	SendMessage, 2024, 0, &var, , ahk_id %_agHwnd%
	; SendMessage 2024, 0, &_gifFile, , ahk_id %_agHwnd%
}

AniGif_UnloadGif(_agHwnd)
{	
	SendMessage 2026, 0, 0, , ahk_id %_agHwnd%
}

AniGif_SetHyperlink(_agHwnd, _url)
{	
	SendMessage 2027, 0, &_url, , ahk_id %_agHwnd%
}

AniGif_Zoom(_agHwnd, _bZoomIn)
{	
	PostMessage 2028, 0, _bZoomIn, , ahk_id %_agHwnd%
}

AniGif_SetBkColor(_agHwnd, _backColor)
{	
	PostMessage 2029, 0, _backColor, , ahk_id %_agHwnd%
}

unusedAnims()
{
	if (n_anim = 0)
	{
		h_aniGifRetro := AniGif_CreateControl(hwnd_retro, K_TILLAFHALFWIDTH_TX, 1, 27, 16, "center")
		AniGif_LoadGifFromFile(h_aniGifRetro, "monty.gif")
	}
	if (n_anim = 3)
	{
		h_aniGifRetro := AniGif_CreateControl(hwnd_retro, K_TILLAFHALFWIDTH_TX, 0, 42, 16, "center")
		AniGif_LoadGifFromFile(h_aniGifRetro, "manicminer.gif")
	}
	if (n_anim = 5)
	{
		h_aniGifRetro := AniGif_CreateControl(hwnd_retro, K_TILLAFHALFWIDTH_TX, 0, 153, 18, "center")
		AniGif_LoadGifFromFile(h_aniGifRetro, "scuba.gif")
	}
	if (n_anim = 6)
	{
		h_aniGifRetro := AniGif_CreateControl(hwnd_retro, K_TILLAFHALFWIDTH_TX, 0, 91, 16, "center")
		AniGif_LoadGifFromFile(h_aniGifRetro, "testmatch.gif")
	}
	if (n_anim = 9)
	{
		h_aniGifRetro := AniGif_CreateControl(hwnd_retro, K_TILLAFHALFWIDTH_TX, 0, 69, 18, "center")
		AniGif_LoadGifFromFile(h_aniGifRetro, "alchie.gif")
	}
	if (n_anim = 11)
	{
		h_aniGifRetro := AniGif_CreateControl(hwnd_retro, K_TILLAFHALFWIDTH_TX, 1, 140, 16, "center")
		AniGif_LoadGifFromFile(h_aniGifRetro, "formula1.gif")
	}
	if (n_anim = 12)
	{
		h_aniGifRetro := AniGif_CreateControl(hwnd_retro, K_TILLAFHALFWIDTH_TX, 0, 96, 20, "center")
		AniGif_LoadGifFromFile(h_aniGifRetro, "turmoil.gif")
	}
}

; Example: Hides the mouse cursor when you press Win+C. To later show the cursor, press Win+C again.
; This script is from www.autohotkey.com/forum/topic6107.html

SystemCursor(OnOff=1)   ; INIT = "I","Init"; OFF = 0,"Off"; TOGGLE = -1,"T","Toggle"; ON = others
{
    static AndMask, XorMask, $, h_cursor
        ,c0,c1,c2,c3,c4,c5,c6,c7,c8,c9,c10,c11,c12,c13 ; system cursors
        , b1,b2,b3,b4,b5,b6,b7,b8,b9,b10,b11,b12,b13   ; blank cursors
        , h1,h2,h3,h4,h5,h6,h7,h8,h9,h10,h11,h12,h13   ; handles of default cursors
    if (OnOff = "Init" or OnOff = "I" or $ = "")       ; init when requested or at first call
    {
        $ = h                                          ; active default cursors
        VarSetCapacity( h_cursor,4444, 1 )
        VarSetCapacity( AndMask, 32*4, 0xFF )
        VarSetCapacity( XorMask, 32*4, 0 )
        system_cursors = 32512,32513,32514,32515,32516,32642,32643,32644,32645,32646,32648,32649,32650
        StringSplit c, system_cursors, `,
        Loop %c0%
        {
            h_cursor   := DllCall( "LoadCursor", "Ptr",0, "Ptr",c%A_Index% )
            h%A_Index% := DllCall( "CopyImage", "Ptr",h_cursor, "UInt",2, "Int",0, "Int",0, "UInt",0 )
            b%A_Index% := DllCall( "CreateCursor", "Ptr",0, "Int",0, "Int",0
                , "Int",32, "Int",32, "Ptr",&AndMask, "Ptr",&XorMask )
        }
    }
    if (OnOff = 0 or OnOff = "Off" or $ = "h" and (OnOff < 0 or OnOff = "Toggle" or OnOff = "T"))
        $ = b  ; use blank cursors
    else
        $ = h  ; use the saved cursors

    Loop %c0%
    {
        h_cursor := DllCall( "CopyImage", "Ptr",%$%%A_Index%, "UInt",2, "Int",0, "Int",0, "UInt",0 )
        DllCall( "SetSystemCursor", "Ptr",h_cursor, "UInt",c%A_Index% )
    }
}
